# About the EventHub

All activity in the **Adobe Experience Platform SDK** (AEP SDK) flows through the **EventHub**. Read the sections below for detailed information on each associated topic.

## [Definition of Terms](DefinitionOfTerms.md)

This page defines terms used throughout the **EventHub** documentation. Review of this page is recommended prior to reading through any other topic.

## [EventHub Contract](Contract.md)

This page outlines the contract that binds interactions between the **EventHub**, **Events**, and **Extensions**. Familiarity with this document is a prerequisite to building an extension for the AEP SDK.

## [Events](Event.md)

Provides a specification for **Events**, which are the objects that allow data to flow through the EventHub.

## [Building Extensions](BuildingExtensions.md)

**Extensions** allow developers to extend the functionality of the AEP SDKs with their code. Third-party extensions are first-class citizens in this ecosystem, and are given access to all of the same features and services provided to first party extensions.
